/**
* 直接操作 sqlite 資料庫;
* 以下欄位為特殊欄位: seq, deleted, acti,byIndex,name
* ID, ENTITY 為數值形態
*/

// 操作資料庫，先設定 db = new APPLS 進行操作
function APPDB(option){

	// this option
	var t = $.extend({
				table:""			// table name
				,seq:0				// seq
				,debug:false		// debug
				,gwc:""				// global where condition
				,wc:""				// user where condition
				,orderby:""			// 排序
				,list_table:""		// list table;
				,list_fields:""	// list fields;
				,has_deleted:false	// has the deleted field
				,has_acti:false	// has the acti field
				,has_byIndex:false	// has the byIndex field
				,fld_unique:""		// field of unique fields
				,fld_name:"name"	// field of name
				,callback:false	// callback function
				,failed:false		// failure message
				,page:1				// page number
				,pagesize:100		// page size
				,table_body:""		// body table
				,ID:0					// ID，不做初始化，由 setID 調用
				,ENTITY:0			// ENTITY，不做初始化，由 setEntity 調用
			}, option);

	var is_init = -1;
	var is_lock = false;			// db 同步的時候，鎖定;

	_init();

function setID(p_id){
	t.ID=parseInt(p_id);
	if(! t.ID) t.ID=0;
	t.gwc = t.gwc + " AND ID="+t.ID;
};
function setEntity(p_entity){
	t.ENTITY=parseInt(p_entity);
	if(! t.ENTITY) t.ENTITY=0;
	t.gwc = t.gwc + " AND ENTITY="+t.ENTITY;
};

function _init(){

	if(! db) return is_init = -1;

	if(t.deleted) t.gwc = t.gwc + " AND deleted=0";
	is_init = true;
};

function setSeq(p_seq){
	var seq=parseInt(p_seq);
	if(! seq) seq=0;
	return t.seq=seq;
};
function setWC(p_wc){
	t.wc = p_wc;
};
function clearWC(){
	t.wc = "";
};
function setPagesize(p_pagesize){
   t.pagesize=parseInt(p_pagesize);
   if(! t.pagesize) t.pagesize=100;
};

function initInfo(){
	if(! isInit()) return false;
	if(! t.seq) return false;
	if(! t.table) return false;
	var sql = "SELECT * FROM "+t.table+" WHERE seq=" + t.seq + t.gwc;
	_sql_initinfo(sql);
	return true;
};

// initialize by unique code;
// the p_code should be array when multi fields as unique;
function initByCode(p_code){
	if(! isInit()) return false;
	if(! t.table) return false;
	if(! t.fld_unique) return false;

	if(t.fld_unique.indexOf(",") != -1){
		var ar=t.fld_unique.split(",");
		var wc="1=1";
		for(i=0; i<ar.length; i++){
			var fld=ar[i];
			var v=p_code[i];
			if(! v) v="";
			wc=wc + " and "+fld+'="'+addslashes(v)+'"';
		}
	}
	else{
		var wc=t.fld_unique+'="'+addslashes(p_code)+'"';
	}

	var sql = "SELECT * FROM "+t.table+" WHERE "+wc+t.gwc;
	_sql_initinfo(sql);
	return true;
};

function _sql_initinfo(sql){
	_debug(sql);
	db.query(sql, function(res){
		if(! res.stat) return retback();
		if(! res.rows.length) return retback();	// not exist;
		return retback(res.rows.item[0]);		// only one item;
	},function(){
		return retback();
	});
};
// return the array of name list;, key is the seq
function getNameList(p_option_yn){
	if(! isInit()) return false;
	var wc=orderby='';
	if(! t.fld_name) return false;
	if(! p_option_yn && t.has_acti) wc = " AND acti>0";
	if(t.wc) wc = wc + " "+t.wc;
	if(t.orderby) orderby=t.orderby;
	else if(t.has_byIndex) orderby="byIndex,"+t.fld_name;
	else orderby=t.fld_name;
	var sql="SELECT seq,"+t.fld_name+" FROM "+t.table+" WHERE 1=1 "+wc+t.gwc + " ORDER BY "+orderby;
	return _get_list(sql);
};
function _get_list(sql){
	_debug(sql);

	db.query(sql, function(res){
		if(! res.stat) return retback();		// failed;
		if(! res.rows.length) return retback({stat:"success"});	// not exist;
		var ret={};
		for(i=0; i < res.rows.length; i++){
			var rs=res.rows.item[i];
			if(typeof(rs)!="object") continue;
			var k=v="";
			var cnt=0;
			for(j in rs){
				cnt++;
				if(cnt==1) k=rs[j];
				else {
					if(!rs[j]) continue;
					v=(v ? v+" (":"") + rs[j] + (v ? ")":"");
				}
			}
			ret[k] = v;
		}
		retback(ret);
	});
	return true;
};
// 有包含無效資料
function getOptionList(){
	return getNameList(1);
};
// key is the code
function getCodeList(){
	if(! isInit()) return false;
	var wc=orderby='';
	if(! t.fld_name) return false;
	if(! t.fld_unique) return false;
	if(t.has_acti) wc = " AND acti>0";
	if(t.orderby) orderby=t.orderby;
	else if(t.has_byIndex) orderby="byIndex,"+t.fld_unique;
	else orderby=t.fld_unique;
	var sql="SEELCT "+t.fld_unique+","+t.fld_name+" FROM "+t.table+" WHERE 1=1 "+wc+t.gwc + " ORDER BY "+orderby;
	return _get_list(sql);
};

// 取資料筆數;
function getCount(){
	if(! isInit()) return false;
	var table=t.list_table ? t.list_table : t.table;
	if(! table) return false;

	var wc = t.gwc.replace("ID=",t.table+".ID=");
	wc = wc.replace("ENTITY=",t.table+".ENTITY=");
	if(t.has_deleted) wc = wc.replace("deleted=",t.table+".deleted=");
	if(t.wc) wc = wc + " "+t.wc;
	sql = "SELECT count(*) as cnt FROM "+table+" WHERE 1=1 "+wc;
	_debug(sql);

	db.query(sql, function(res){
		if(! res.stat) return retback();
		if(! res.rows.length) return retback();
		var rs=res.rows.item[0];
		if(rs) return retback({cnt:rs["cnt"]});
		return retback();
	});
	return true;
};
// 取資料;
function getList(){
	if(! isInit()) return false;
	var table=t.list_table ? t.list_table : t.table;
	if(! table) return false;

	var wc = t.gwc.replace("ID=",t.table+".ID=");
	wc = wc.replace("ENTITY=",t.table+".ENTITY=");
	if(t.has_deleted) wc = wc.replace("deleted=",t.table+".deleted=");
	if(t.wc) wc = wc + " "+t.wc;

	var fields = t.list_fields ? t.list_fields : '*';
	var orderby = t.orderby ? " order by "+t.orderby : "";
	var groupby = t.groupby ? " group by "+t.groupby : "";

	if(! t.page || t.page <= 1) t.page = 1;
	if(! t.pagesize || t.pagesize <= 0) t.pagesize = 100;
	var from = (t.page -1) * t.pagesize;
	sql = "SELECT "+fields+" FROM "+table+" WHERE 1=1 "+wc + groupby + orderby + " LIMIT "+from+","+t.pagesize;
	_debug(sql);

	db.query(sql, function(res){
		if(! res.stat) return retback();		// failed;
		var ret={};
		for(i=0; i < res.rows.length; i++){
			var rs=res.rows.item[i];
			if(typeof(rs)!="object") continue;
			ret[i] = rs;
		}
		return retback(ret);
	});
	return true;
};


// 新增資料;
function add(p_value, p_body){
	if(! isInit()) return false;
	if(typeof(p_value) != "object") return false;
	if(! t.table) return false;

	if(t.ID) p_value["ID"] = t.ID;
	if(t.ENTITY) p_value["ENTITY"] = t.ENTITY;

	// 一定要有流水號;
	var sql="SELECT MAX(seq) seq FROM "+t.table;

	db.query(sql, function(res){
		if(! res.stat) return retback();		// failed;
		var seq=0;
		if(res.rows.length){
			var rs = res.rows.item[0];
			var seq=rs["seq"];
		}
		if(!seq) seq=0;
		seq++;

		// 流水號由外部指定;
		if(p_value.seq) seq = p_value.seq;

		var s1="seq,";
		var s2='"'+seq+'",';
		for(k in p_value){
			if(k == "seq") continue;
			s1=s1+k+',';
			s2=s2+'"'+addslashes(p_value[k])+'",';
		}
		var sql="INSERT INTO "+t.table+" ("+s1.substring(0,s1.length -1)+") values ("+s2.substring(0,s2.length -1)+")";
		_debug(sql);

		db.add(sql, function(resadd){
			if(! resadd.stat) return false;
			t.seq=seq;		// set seq
			if(p_body) dealBody(p_body);	// body 結果不做返回;
			return retback({seq:seq});
		});
	});
	return true;
};

function update(p_value, p_body){
	if(! isInit()) return false;
	if(typeof(p_value) != "object") return false;
	if(! t.table) return false;
	if(! t.seq) return false;

	var s=sql="";
	for(k in p_value){
		if(k == "seq") continue;
		s=s+k+'="'+addslashes(p_value[k])+'",';
	}
	if(! s) return retback();
	var sql="UPDATE "+t.table + " SET "+s.substring(0,s.length -1)+" WHERE seq="+t.seq;
	_debug(sql);

	db.update(sql,function(res){
		if(! res.stat) return retback();	// failed;
		if(p_body) dealBody(p_body);		// body 處理結果不做返回
		return retback({seq:t.seq});
	});
	return true;
};

// body 的資料處理相對簡單，先刪除再新增
// 關鍵欄位是 par_seq;
function dealBody(p_body){
	if(! p_body || typeof(p_body) != "object") return false;
	if(! t.table_body) return false;
	if(! t.seq) return false;

	var sql="DELETE FROM "+t.table_body+" WHERE par_seq="+t.seq;
	_debug(sql);

	// 先找出流水;
	var sql="SELECT MAX(seq) seq FROM "+t.table_body;
	_debug(sql);
	db.query(sql,function(res){
		var seq=0;
		if(res.rows.length){
			var rs = res.rows.item[0];
			var seq=rs["seq"];
		}
		if(!seq) seq=0;

		// 再新增
		for(i in p_body){
			if( typeof(p_body[i]) != "object") continue;

			seq ++;
			// 如果外部指定
			if(p_body[i]["seq"]) seq = p_body[i]["seq"];

			var s1="par_seq,seq,";
			var s2='"'+t.seq+'","'+seq+'",';
			for(k in p_body[i]){
				if(k == "par_seq" || k == "seq") continue;
				s1=s1+k+',';
				s2=s2+'"'+addslashes(p_body[i][k])+'",';
			}
			var sql="INSERT INTO "+t.table_body+" ("+s1.substring(0,s1.length -1)+") values ("+s2.substring(0,s2.length -1)+")";
			_debug(sql);
			db.add(sql);
		}
	});
	return true;
};

// 資料刪除，不做資料檢查;
function del(p_seqs){
	if(! isInit()) return false;
	if(! p_seqs && ! t.seq) return false;
	if(p_seqs && typeof(p_seqs) != "object") return false;
	if(! p_seqs) p_seqs = [t.seq];
	var ret={rows:p_seqs.length};

	if(! t.table) return false;
	var wc = ' ("'+ p_seqs.join('","') +'")';
	var sql="DELETE FROM "+t.table+" WHERE seq IN "+wc;
	_debug(sql);

	db.del(sql,function(res){
		if(! res.stat) return retback();

		if(! t.table_body) return retback(ret);

		var sql="DELETE FROM "+t.table_body + " WHERE par_seq IN "+wc;
		_debug(sql);
		db.del(sql,function(){
			return retback(ret);
		});
	});
	return true;
};

// 按條件刪除資料
function delByWC(p_wc){
	if(! isInit()) return false;
	if(! t.table) return false;
	if(! p_wc) return false;
	var sql="DELETE FROM "+t.table+" WHERE "+p_wc + t.gwc;
	_debug(sql);

	db.del(sql,function(res){
		if( res.stat) return retback();

		return retback({done:true});
	});
	return true;
};

// 修改排列順序
function chgorder(p_order){
	if(! isInit()) return false;
	if(! t.table) return false;
	if(! t.has_byIndex) return false;
	if(typeof(p_order) != "object") return false;
	var len = p_order.length;
	var ret={rows:len};

	var k=1;
	for(i in p_order){
		var sql="UPDATE "+t.table+" SET byIndex="+k+' WHERE seq="'+addslashes(p_order[i])+'"';
		_debug(sql);
		k++;
		db.update(sql,function(){
			if(k == len) return retback(ret);
		});
	}
	return true;
};
function updrows(p_seqs,p_value){
	if(! isInit()) return false;
	if(! t.table) return false;
	if(typeof(p_seqs) != "object") return false;
	if(typeof(p_value) != "object") return false;
	var ret={rows:p_seqs.length};

	var wc = ' ("'+ p_seqs.join('","') +'")';
	var s=sql="";
	for(k in p_value){
		if(k == "seq") continue;
		s=s+k+'="'+addslashes(p_value[k])+'",';
	}
	if(! s) return retback();
	var sql="UPDATE "+t.table + " SET "+s.substring(0,s.length -1)+" WHERE seq IN "+wc;
	_debug(sql);

	db.update(sql,function(res){
		if(! res.stat) return retback();
		return retback( ret);
	});
	return true;
};

function addslashes(p_str){
	if(typeof(p_str)!="string") return p_str;
	return p_str.replace(/"/g, '""');
};

// debug log
function _debug(p_msg){
	if(! t.debug) return false;
	var d=new Date();
	var c=d.getHours()+":"+d.getMinutes()+":"+d.getSeconds()+"."+d.getMilliseconds();
	$("#log").append("<p>"+c+"	"+p_msg+"</p>");
	return console.log(c+"	"+p_msg);
};

// callback is object
function retback(ret){
	if(t.callback){
		if(ret && typeof(ret)=="object") ret.stat = "success";
		else ret={stat:"fail","msg":t.failed};
		return t.callback(ret);
	}
	return ret;
};

// 對外初始化;
function setup(callback){
	t.failed = false;
	t.callback = callback;
};
function opFailed(p_failed_code){
	t.failed=p_failed_code;
	return retback();
};
function isInit(){
	if(is_init <=0) return opFailed("ERR_INIT");
	return true;
};
	// public methods
	return {
		isInit:function(){
			return is_init;
		}
		,setSeq:function(seq){
			return setSeq(seq);
		}
		,setWC:function(wc){
			return setWC(wc);
		}
		,clearWC:function(){
			return clearWC();
		}
		,initInfo:function(callback){
			setup(callback);
			return initInfo();
		}
		,initByCode:function(code,callback){
			setup(callback);
			return initByCode(code);
		}
		,getNameList:function(callback){
			setup(callback);
			return getNameList();
		}
		,getOptionList:function(callback){
			setup(callback);
			return getOptionList();
		}
		,getCodeList:function(callback){
			setup(callback);
			return getCodeList();
		}
		,getCount:function(callback){
			setup(callback);
			return getCount();
		}
		,getList:function(callback){
			setup(callback);
			return getList();
		}
		,add:function(p_value,p_body,callback){
			setup(callback);
			return add(p_value,p_body);
		}
		,update:function(p_value,p_body,callback){
			setup(callback);
			return update(p_value,p_body);
		}
		,del:function(callback){
			setup(callback);
			return del();
		}
		,delrows:function(p_seqs,callback){
			setup(callback);
			return del(p_seqs);
		}
		,chgorder:function(p_orders,callback){
			setup(callback);
			return chgorder(p_orders);
		}
		,updrows:function(p_seqs,p_value,callback){
			setup(callback);
			return updrows(p_seqs,p_value);
		}
		,delByWC:function(p_wc,callback){
			setup(callback);
			return delByWC(p_wc);
		}
		,setEntity:function(p_entity){
			return setEntity(p_entity);
		}
		,setID:function(p_id){
			return setID(p_id);
		}
		,setPagesize:function(p_pagesize){
			return setPagesize(p_pagesize);
		}
	};
};		// end of function ls()

