/**
* 基本操作;
*/

function HVBASIC(option){

	// this option
	var t = $.extend({
				debug:false		// debug
				,form_id:''		// form id
			}, option);
	var ar_errmsg=['required','int format','date format','decimal format','email format','field format'];

function setMsgLang(){
   var ar_errmsg_lang = {"zh-tw":["必須輸入","請輸入整數格式","請輸入日期格式","請輸入整數格式","請輸入電子郵件格式","僅限字母或數字 (a-z 0-9)"],"zh-cn":["必须输入","请输入整数格式","请输入日期格式","请输入数值格式","请输入电子邮件格式","仅限字母或数字 (a-z 0-9)"],"en-us":["required","int format","date format","decimal format","email format","field format"]};
   if(typeof(g_lang) != "undefined" ) {
      ar_errmsg = ar_errmsg_lang[g_lang];
   }
}


function setFormID(p_id){
	t.form_id = p_id;
};

function initFormID(obj){
	if(! obj) return false;
	var n=$(obj).parents("form").attr("id");
	if(n) return t.form_id=n;
	return false;
};

function _getIdForm(){
	if(! t.form_id) return false;
	return "form#"+t.form_id+" ";
};
function dataCheck(){
	var id_form=_getIdForm();
	if( ! id_form) return false;

	setMsgLang();

	var sw=0;
	$(id_form+"em.datacheck").remove();
	$(id_form+" .field-fail").removeClass("field-fail");

	// check not null
	$(id_form+".notnull").each(function(){
		var val = $(this).val();
		// $(this).val() is array when multi-select return
		if(val==null || $.trim(String(val)) == ''){
			$(this).parent().addClass('field-fail').append('<em class="datacheck">'+ar_errmsg[0]+'</em>');
			sw ++;
		}
		if(sw == 1) $(this).focus();
	});
	if(sw) return false;

	// data type
	$(id_form+".datatype").each(function(){
		var n=$(this).attr('n');
		var msg='';
		var v=$.trim($(this).attr('value'))+'';
		if(v){
			switch(n){
				case 'i':
					if(! isInt(v) ) msg=ar_errmsg[1];
					break;
				case 'd':
					if(! isDate(v) ) msg=ar_errmsg[2];
					break;
				case 'f':
					if(! isDecimal(v) ) msg=ar_errmsg[3];
					break;
				case 'e':
					if(! isEmail(v) ) msg=ar_errmsg[4];
					break;
				case 'k':
					if(! isField(v) ) msg=ar_errmsg[5];
					break;
			}
		}
		if(msg != ''){
			$(this).parent().addClass('field-fail').append('<em class="datacheck">'+msg+'</em>');
			sw++;
			if(sw == 1) $(this).focus();
		}
	});
	if(! sw) return true;
	return false;
};

// data check
function isEmail(e){
	var reg = new RegExp("^[_\.0-9a-zA-Z-]+@([0-9a-zA-Z-]+\.)+[a-zA-Z]{2,3}$");
	if(e.search(reg)!=-1) return true;
	return false;
};
function isDate(d){
	if(d.indexOf('/') <= 0) d = d.replace(/-/g,'/');
	var dt = new Date(d);
	var y = dt.getYear();
	if( isNaN (y)) return false;
	return true;
};
function isInt(x){
	return (x % 1) == 0;
};
function isDecimal(x) {
	return ($.trim(x)+'').match(/^(((\+|\-)?\d+(\.\d*)?)|((\+|\-)?(\d*\.)?\d+))$/) != null;
};
function isField(f){
	var reg = new RegExp("^([_@\.0-9a-zA-Z-])+$");
	if(f.search(reg)!=-1) return true;
	return false;
};

// 去除小數後的0、千分號
function formatNum(p_num){
	try{
		var s=p_num.toString().split(".");
		if(s[0].length > 3){
			s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, ',');
		}
		s[1]=parseInt(s[1]);
		if(! s[1]) return s[0];
		return s[0] + "." + s[1];
	}
	catch(e){return "";}
};

function URLEncode(clearString) {
	var output = '';
	var x = 0;
	clearString = clearString.toString();
	var regex = /(^[a-zA-Z0-9_.]*)/;
	while (x < clearString.length) {
		var match = regex.exec(clearString.substr(x));
		if (match != null && match.length > 1 && match[1] != '') {
			output += match[1];
			x += match[1].length;
		} else {
			if (clearString[x] == ' ')
				output += '+';
			else {
				var charCode = clearString.charCodeAt(x);
				var hexVal = charCode.toString(16);
				output += '%' + ( hexVal.length < 2 ? '0' : '' ) + hexVal.toUpperCase();
			}
			x++;
		}
	}
	return output;
};

function htmlspecialchars(p_str){
	try{
		var str = p_str.replace(/\</g,"&lt;");
		str = str.replace(/\>/g,"&gt;");
		str = str.replace(/\"/g,"&quot;");
		str = str.replace(/\n/g,"<br />");
	}
	catch(e){
		str='-';
	}
	return str;
};

// json to object
function j2o(p_json){
	if(typeof(p_json) == "object") return p_json;
	var ret={};
	try{
		ret =$.parseJSON(p_json);
		return ret;
	}catch(e){return ret;}
};

// object to json string
function o2j(p_obj){
	if(typeof(p_obj) == "object"){
      return JSON.stringify(p_obj);
   }
	return p_obj;
};

function parseUri(str) {
	var o = {strictMode: false,
				key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],
				q:	{ name:	"queryKey", parser: /(?:^|&)([^&=]*)=?([^&]*)/g },
				parser: {
					strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
					loose: /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
				}
			};
	var m = o.parser[o.strictMode ? "strict" : "loose"].exec(str);
	var uri = {};
	var i = 14;

	while (i--) uri[o.key[i]] = m[i] || "";

	uri[o.q.name] = {};
	uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
		if ($1) uri[o.q.name][$1] = $2;
	});

	return uri;
};

	// public methods
	return {
		htmlspecialchars:function(x){
			return htmlspecialchars(x);
		}
		,formatNum:function(x){
			return formatNum(x);
		}
		,isEmail:function(x){
			return isEmail(x);
		}
		,isInt:function(x){
			return isInt(x);
		}
		,isDecimal:function(x){
			return isDecimal(x);
		}
		,isField:function(x){
			return isField(x);
		}
		,URLEncode:function(x){
			return URLEncode(x);
		}
		,parseUri:function(x){
			return parseUri(x);
		}
		,setFormID:function(x){
			return setFormID(x);
		}
		,initFormID:function(node){
			return initFormID(node);
		}
		,dataCheck:function(){
			return dataCheck();
		}
		,j2o:function(str){
			return j2o(str);
		}
		,o2j:function(o){
			return o2j(o);
		}
	};
};		// end of function
