/**
* 從資料庫中讀取 cache 等操作
*/

var HVJS = (window.JsInterface)?(window.JsInterface):new iOSWrapper();
var apphvjs_callbacks = [];

function APPHVJS(option){

	var t = $.extend({
				dbname:""			// web access url
				,callback_id:0		// callback id;
				,callbacks:[]		// callbacks
				,debug:false		// debug
			}, option);

	var is_init = false;

	init();


// init the items
function init(){
	if(! t.dbname) return is_init = -1;
	if(! HVJS) return is_init = -1;

	return is_init = 1;
};

// 對外初始化;
function setup(callback){
	t.callback_id ++;
	apphvjs_callbacks[t.callback_id] = callback;
};

// debug log
function _debug(p_msg){
	if(! t.debug) return false;
	var d=new Date();
	var c=d.getHours()+":"+d.getMinutes()+":"+d.getSeconds()+"."+d.getMilliseconds();
	return $("#log").append("<p>"+c+"      "+p_msg+"</p>");
};

function getCache(p_table){
	if( is_init <= 0) return false;
	
	return HVJS.getCache(t.dbname, p_table, "apphvjs_callback",t.callback_id);
};

function getTick(p_table){
	if( is_init <= 0) return false;
	return HVJS.getTick(t.dbname, p_table, "apphvjs_callback",t.callback_id);
};

function reload(){
	if( is_init <= 0) return false;
	return HVJS.doSync("apphvjs_callback",t.callback_id);
};
function add(sql){
	if( is_init <= 0) return false;
	return HVJS.add(t.dbname,sql,"apphvjs_callback",t.callback_id);
};
function update(sql){
	if( is_init <= 0) return false;
	return HVJS.update(t.dbname,sql,"apphvjs_callback",t.callback_id);
};
function del(sql){
	if( is_init <= 0) return false;
	return HVJS.del(t.dbname,sql,"apphvjs_callback",t.callback_id);
};
function query(sql){
	if( is_init <= 0) return false;
	return HVJS.query(t.dbname,sql,"apphvjs_callback",t.callback_id);
};
function getItem(key){
	if( is_init <= 0) return false;
	return HVJS.getItem(t.dbname,key,"apphvjs_callback",t.callback_id);
};
function setItem(key,val){
	if( is_init <= 0) return false;
	var h = new HVBASIC();
	v = h.o2j(val);
	return HVJS.setItem(t.dbname,key,v,"apphvjs_callback",t.callback_id);
};
function chkConnection(){
	if( is_init <= 0) return false;
	return HVJS.chkConnection("apphvjs_callback",t.callback_id);
};
function getDeviceID(){
	if( is_init <= 0) return false;
	return HVJS.getDeviceID("apphvjs_callback",t.callback_id);
};
function goBack(){
	if( is_init <= 0) return false;
	return HVJS.goBack();
};
function getLoginInfo(){
	if( is_init <= 0) return false;
	return HVJS.getLoginInfo("apphvjs_callback",t.callback_id);
};
	// public methods
	return {
		isInit:function(){	// 是否初始化完成：HTML5 support + 連上網路
			return is_init;
		}
		// 以下需要考慮是否完成初始化操作;
		,cache:function(table,callback){	// cache 的內容;
			setup(callback);
			return getCache(table);
		}
		,tick:function(table,callback){	// cache 的內容;
			setup(callback);
			return getTick(table);
		}
		,reload:function(callback){		//  重新載入
			setup(callback);
			return reload();
		}
		,add:function(sql,callback){		// 新增
			setup(callback);
			return add(sql);
		}
		,update:function(sql,callback){		// 修改
			setup(callback);
			return update(sql);
		}
		,del:function(sql,callback){		// 刪除
			setup(callback);
			return del(sql);
		}
		,query:function(sql,callback){		// 查詢
			setup(callback);
			return query(sql);
		}
		,setItem:function(key,val,callback){		// 設定 local storage
			setup(callback);
			return setItem(key,val);
		}
		,getItem:function(key,callback){		// 查詢 local storage
			setup(callback);
			return getItem(key);
		}
		,chkConnection:function(callback){		// 檢查網絡連線
			setup(callback);
			return chkConnection();
		}
		,getDeviceID:function(callback){		// 取得device id
			setup(callback);
			return getDeviceID();
		}
		,goBack:function(){		// back
			return goBack();
		}
		,getLoginInfo:function(callback){
			setup(callback);
			return getLoginInfo();
		}
	};

};		// end of function ls()

/**
* data is string format;
*/
function apphvjs_callback(d){
	var h = new HVBASIC();
	var data = h.j2o(d);
	if(! data) return false;

	if(data.result) data.result=h.j2o(data.result);

	var callback=apphvjs_callbacks[data.callback_id];

	if(callback) return callback(data);
};
