var	TOUCH_DOWN = '', //用以定義按下事件
		TOUCH_UP = '', //用以定義放開事件
		isBrowser = true, //供瀏覽器測試用，在PhoneGap中須改為false
		CONN_TIME_OUT = 5000, //連接超時
		myScroll = [];


window.EF = {
	DeviceReady: 0,
	Touch: {
		Down: 'mousedown',
		Up: 'mouseup'
	},
	Connection: {
		Network: {
			stat: 0,
			msg: '尚未連接網路'
		},
		Server: {
			stat: 0,
			msg: '尚未連接伺服器'
		}
	},
	DeviceInfo: {
	},
	Debug: false
}

/* 捕獲整個瀏覽器的touchmove事件 */
function preventBehavior(e) { 
	e.preventDefault();
};
//document.addEventListener("touchmove", preventBehavior, false);


function onBodyLoad() {
	if (isBrowser) {
		$(window).load(function() { onDeviceReady() });
	} else {
		document.addEventListener("deviceready", onDeviceReady, false);
	}
}

function getDeviceInfo() {
	EF.DeviceInfo = {
		name:  device.name,
		phonegap:  device.phonegap,
		platform:  device.platform,
		uuid:  device.uuid,
		version:  device.version
	}
	if (device.platform == "android") {
		document.addEventListener("backbutton", backButtonDown, false);
		document.addEventListener("menubutton", menuButtonDown, false);
		document.addEventListener("searchbutton", searchButtonDown, false);
	}
}

function onDeviceReady() { /* PhoneGap載入成功，開始執行WebApp */
	if (!isBrowser) {
		EF.DeviceReady = 1;
		getDeviceInfo();
	}
	checkConnection(0);
	setTimeout(EFRun,100);
}

function EFRun() {
	//
}

function backButtonDown() {
	showConfirm("提醒",'確定退出？','確定,取消');
}

function menuButtonDown() { 
	// Menu Button
}

function searchButtonDown() { 
	// Search Button
}

function showAlert(title,desc,btn) {
	if (EF.DeviceReady==1) {
		if (title=="") title = "提醒";
		if (desc=="") desc = "提醒內容";
		if (btn=="") btn = "確定";
		var alertDismissed = function() {
			//do something
			return false;
		}
		navigator.notification.confirm(desc, alertDismissed, title, btn)
	} else {
		alert(desc);
	}
}

function showConfirm(title,desc,btn,func) {
	if (!func) func = 'onConfirm';
	if (EF.DeviceReady==1) {
		navigator.notification.confirm(desc, function(stat){
			if (stat == "2") eval(func);
		}, title, btn);
	} else {
		var r = confirm(desc);
		if (r == true) {
			eval(func);
		}
	}
}

function onConfirm(btn) {
	if (btn == "1") {
		device.exitApp();
	}
}

function showPrompt(desc,def,type) {
	var str = prompt(desc,def);
	switch (type) {
		case 'qty':
			str = parseInt(str);
			if (str<1) showPrompt(desc,def,type);
			break;
		default:
			str = str;
	}
	return str;
}

function genRandomID() {
	var randnum="";
	for(var i=0;i<16;i++) {
		randnum+=Math.floor(Math.random()*10);
	}
	return randnum;
}

function getPropertyCount(o){  
   var n, count = 0;  
   for(n in o){  
      if(o.hasOwnProperty(n)){  
         count++;  
      }  
   }  
   return count;  
}

function doScroll() {
	$.each($(".iwrap"),function(i,item){
			 if (! $(item).attr("id")) {
			 setScroll(item);
			 } else {
			 if ($(item).attr("id").indexOf("iwrap_")<0) {
			 //非自動產生的iwrap，需要重復iscroll
			 }
			 }
			 });

}

function refreshScroll() {
	for(var tag in myScroll) {
		if (myScroll[tag]!=null) {
			//alert(tag);
			myScroll[tag].refresh();
		}
	}
}

function setScroll(item) {
	//設定iScroll
	var rnum = genRandomID();
	wrapID = "iwrap_" + rnum;
	wrapEl = "#" + wrapID;
	$(item).attr("id",wrapID);
	hs = ($(item).attr("hs")==1)?true:false;
	vs = ($(item).attr("vs")==1)?true:false;
	cc = ($(item).attr("cc")==0)?false:true;
	ld = ($(item).attr("lc")==0)?false:true;
	mm = ($(item).attr("mm")==0)?false:true;
	bn = ($(item).attr("bn")==0)?false:true;
	sn = ($(item).attr("sn"))?$(item).attr("sn"):false;
	if ($(item).hasClass("hwrapper")) {
		loadWrapper(wrapID,hs,vs,cc,ld,mm,sn,bn);
	} else if ($(item).hasClass("vwrapper")) {
		loadWrapper(wrapID,hs,vs,cc,ld,mm,sn,bn);
	}

}

function loadWrapper(tag,hs,vs,cc,ld,mm,sn,bn) {
	myScroll[tag] = new iScroll(tag, {
										 hScrollbar: hs,
										 vScrollbar: vs,
										 checkDOMChanges: cc,
										 lockDirection: ld,
										 momentum: mm,
										 snap: sn,
										 bounce: bn,
										 useTransform: false,
										 onBeforeScrollStart: function (e) {
										 var target = e.target;
										 while (target.nodeType != 1) target = target.parentNode;
										 if (target.tagName != 'SELECT' && target.tagName != 'INPUT' && target.tagName != 'TEXTAREA')
										 e.preventDefault();
										 }
										 });
}

var foreach = function (obj, insp){
	if(obj == null && obj.constructor != Array){
		return [];
	}
	var i=0, len = obj.length, r = [];
	while(i<len){
		var x = insp(obj[i], i);
		if (x !== null) {
			r[r.length] = x;
		}
		i++;
	}
	return r;
};

var ArrayWithout = function(){
	if (arguments.length < 2) {
		return arguments.length == 1 ? arguments[0] : null;
	}
	var results = [];
	var aa = arguments[0];
	if (aa === null || aa.constructor != Array) {
		return null;
	}
	if(arguments[1].constructor == Array){
		var args = [];
		args[0] = aa;
		foreach(arguments[1], function(v, i){
				  args[i+1] = v;
				  });
	}
	else{
		args = arguments;
	}
	for(var i = 0;i < aa.length; i ++){
		var isWithout = true;
		for(var j = 1; j < args.length ; j ++){
			if(aa[i] == args[j]){
				isWithout = false;
				break;
			}
		}
		if (isWithout) {
			results.push(aa[i]);
		}
	}
	return results;
};

Number.prototype.formatMoney = function(c, d, t){ //擴展Number對象，便於生成金額，c是截取小數點後的長度，d是小數點的符號，t是千分位分隔符
	var n = this, c = isNaN(c = Math.abs(c)) ? 2 : c, d = d == undefined ? "," : d, t = t == undefined ? "." : t, s = n < 0 ? "-" : "", i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + "", j = (j = i.length) > 3 ? j % 3 : 0;
	return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
};

function in_array(stringToSearch, arrayToSearch) {
	for (s = 0; s < arrayToSearch.length; s++) {
		thisEntry = arrayToSearch[s].toString();
		if (thisEntry == stringToSearch) {
			return true;
		}
	}
	return false;
}

function checkConnection(alertType) {
   if (! EF.DeviceReady) return 1;
   var networkState = navigator.network.connection.type;
   var states = {};
   states[Connection.UNKNOWN]  = '網路連接狀態異常';
   states[Connection.ETHERNET] = 'Ethernet connection';
   states[Connection.WIFI]     = '正在使用WiFi連接';
   states[Connection.CELL_2G]  = '正在使用Cell 2G連接';
   states[Connection.CELL_3G]  = '正在使用Cell 3G連接';
   states[Connection.CELL_4G]  = '正在使用Cell 4G連接';
   states[Connection.NONE]     = '沒有連接到網路';
   //showAlert("網路狀態",states[networkState],"確認");
   var stateArr = ['wifi'];
   if (in_array(networkState,stateArr)) return 1;
   else return 0;
   //('Connection type: ' + states[networkState]);
}

function vardump(obj,objname,deep){
	deep = deep||1;
	if(deep > 5) return "";
	deep++;
	var vd_str = "";
	/* 不是對象或數組 */
	if(typeof(obj) != 'object' && typeof(obj) != 'array'){
		vd_str += "<div>"+objname+"Not Object or Array["+typeof(obj)+"]</div>";
		return '';
	}
	/* Print */
	vd_str += "\n";
	for(var i in obj){
		vd_str += "\n  ";
		vd_str += objname+'['+i+'] = '+obj[i];
		if(typeof(obj[i]) == 'object' || typeof(obj[i]) == 'array'){
			vardump(obj[i],objname+'['+i+']',deep);
		}
		vd_str += "";
	}
	vd_str += "";
	alert(vd_str);
}

function loading(stat,level) {
	if (!level) level = false;
   if (stat == "show") {
      if (level) $("#overlay").show();
      $("#loading").show();
   } else {
      $("#loading").hide();
      $("#overlay").hide();
   }
}

function doResize() {
	doMyResize();
	if ($(window).width()>768) {
		$("body#app").addClass("horizontal").removeClass("vertical");
	} else {
		$("body#app").addClass("vertical").removeClass("horizontal");
	}
	refreshScroll();
}

function doMyResize() {
	//
}

function reload() {
	 window.location.reload();
}

$(function(){
	onBodyLoad();
	if (Modernizr.touch) {
		EF.Touch.Down = "touchstart";
		EF.Touch.Up = "touchend";
	}
	TOUCH_DOWN = EF.Touch.Down;
	TOUCH_UP = EF.Touch.Up;

	$(window).resize(function(){ doResize(); });

	doResize();

	//$("body").append('<div id="overlay"></div><div id="loading" class="corner-all"><i class="icon icon-loading spin">&nbsp;</i><h1>Loading...</h1></div>');
	//$(".button").live(TOUCH_DOWN,function(){$(this).addClass("button-down");}).live(TOUCH_UP,function(){$(this).removeClass("button-down")});
  
	doScroll();
  
});
